import tester.*;

class Examples{
	IDoor toAlaska = new Escape("Alaska");
	IDoor toNorthPole = new Escape("North Pole");
	Room northRoom = new Room(toAlaska, toNorthPole);
	IDoor toRoom = new Into(northRoom);
	Short littleGate = new Short(northRoom, 5.0);
	Locked redDoor = new Locked(northRoom, "red");

	IDoor meadow = new Escape("meadow");
	IDoor street = new Escape("street");
	Room ms = new Room(meadow, street);
	Room planets = new Room(new Escape("mars"),new Escape("venus"));
	Room maze = new Room(new Into(ms), new Into(planets));
	
	Person annie = new Person("Alaska", 5.1, "red");
	Person sandra = new Person("Alaska", 4.8, "green");
	Person joe = new Person("Arizona", 5.0, "blue");
	Person santa = new Person("North Pole", 5.6, "orange");
	Person elmo = new Person("street", 2.0, "yellow");

	void tests(Tester t) {
		t.checkExpect(redDoor.escapePath(annie), new Left(new Immediate()));
		t.checkExpect(redDoor.escapePath(sandra), new Fail());
		t.checkExpect(redDoor.escapePath(elmo), new Fail());
		
		t.checkExpect(littleGate.escapePath(annie), new Fail());
		t.checkExpect(littleGate.escapePath(sandra), new Left(new Immediate()));
		t.checkExpect(littleGate.escapePath(elmo), new Fail());
		t.checkExpect(toRoom.escapePath(annie), new Left(new Immediate()));
		t.checkExpect(toRoom.escapePath(joe), new Fail());
		t.checkExpect(toRoom.escapePath(santa), new Right(new Immediate()));
		t.checkExpect(new Into(maze).escapePath(elmo), new Left(new Right(new Immediate())));
		t.checkExpect(annie.isShorter(6.0), true);
		t.checkExpect(annie.isShorter(5.0), false);
		t.checkExpect(annie.isShorter(5.1), false);
		t.checkExpect(annie.isDest("Alaska"), true);
		t.checkExpect(annie.isDest("Arizona"), false);
		t.checkExpect(annie.hasKey("red"), true);
		t.checkExpect(annie.hasKey("blue"), false);
	}
}
